#!/bin/sh

Do ()
{

ID_PAT=`ls IN-a--* | awk '{ gsub(/IN\-a\-\-/," "); printf("%s ", $0); }'`

for ID in \
        $ID_PAT
do

	awk '{print $0" "'$ID'}' mat.$ID
	
done

}

echo 'Integrating the results fitted'

Do | sort | \
	awk 'BEGIN{ NN=0; }\
		{ \
			if( NN!=$1 && NN>0 ){ \
				s = 0; Fx = 0; \
				for ( p in F ) { \
					if ( Fx < F[p] ) { \
						Fx = F[p]; s = p; \
					} \
				} \
				if ( s==0 ) s=1; \
				print NN" "s; \
			} \
			NN=$1; p=$3; F[p]=$2; \
		}' | \
	awk 'BEGIN{ id=-1; } \
		{ \
			if ( $2 == id ) next; \
			print $0; id = $2; \
		}'  | \
	awk 'BEGIN{ i=0; } \
		{ s[i]=$1; id[i]=$2; i++; kernel[$2]=1; } \
		END{ \
			for ( p in kernel ) { \
				print "#define\tKERNEL_"p"\t"kernel[p]; \
			} \
			printf("\n"); \
			s[i] = 1000000; \
			for(j=0;j<i;j++){\
				print "if ( n >= "s[j]" && n < "s[j+1]" ) {"; \
				print "\tBLK = "id[j]";"; \
				print "} else"; \
			} \
			print "\tBLK = "id[0]";"; \
		}' > dgemvn-auto.h


