#if 0
<--/****************************************
Automatic Performance Tuning for DSYMV-U
Tue Feb 24 00:22:42 JST 2015
Host on gauss.aics27.riken.jp
Device is GeForce-GTX-580
****************************************/-->
DEVICE= GeForce-GTX-580
MP= 16
CG= 200
MAXmem= 1610285056
MAXDIM= 12768
MAXDIM2= 18057
MAXDIM3= 9028
CUDA= 7000
#define CURRENT_GPU 200
#endif
{
//==========
if(blk==-1){
	#include "dsymv-upper-auto2.h"
}
//==========
#if 0
struct dsymv_auto_tuning_param_t { 
	int	BLOCK_SIZE, VX, UX, MULTI, MX; 
} PARAM[22] = {
	{ 128, 2, 24, 2, 1 },
	{ 64, 3, 30, 2, 1 },
	{ 128, 2, 28, 2, 6 },
	{ 32, 6, 24, 2, 3 },
	{ 32, 4, 16, 3, 9 },
	{ 128, 2, 24, 2, 3 },
	{ 128, 2, 28, 2, 3 },
	{ 64, 3, 30, 2, 7 },
	{ 64, 2, 20, 4, 1 },
	{ 64, 4, 28, 2, 9 },
	{ 32, 6, 24, 3, 7 },
	{ 32, 5, 20, 2, 1 },
	{ 128, 2, 28, 2, 0 },
	{ 128, 2, 24, 2, 9 },
	{ 64, 3, 24, 2, 1 },
	{ 64, 2, 20, 4, 7 },
	{ 64, 3, 30, 2, 6 },
	{ 32, 6, 24, 3, 1 },
	{ 64, 4, 28, 2, 7 },
	{ 32, 6, 24, 3, 9 },
	{ 0, 0, 0, 0, 0 }
};
#endif
//==========
switch ( BLK ) {
#if KERNEL_1
case 1:
	API(SYMVu_ATOMIC_host) < GPU_ARCH, scalar_t, 128, 2, 24, 2, 1 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_2
case 2:
	API(SYMVu_ATOMIC_host) < GPU_ARCH, scalar_t, 64, 3, 30, 2, 1 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_3
case 3:
	API(SYMVu_ATOMIC_host) < GPU_ARCH, scalar_t, 128, 2, 28, 2, 6 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_4
case 4:
	API(SYMVu_ATOMIC_host) < GPU_ARCH, scalar_t, 32, 6, 24, 2, 3 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_5
case 5:
	API(SYMVu_ATOMIC_host) < GPU_ARCH, scalar_t, 32, 4, 16, 3, 9 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_6
case 6:
	API(SYMVu_ATOMIC_host) < GPU_ARCH, scalar_t, 128, 2, 24, 2, 3 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_7
case 7:
	API(SYMVu_ATOMIC_host) < GPU_ARCH, scalar_t, 128, 2, 28, 2, 3 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_8
case 8:
	API(SYMVu_ATOMIC_host) < GPU_ARCH, scalar_t, 64, 3, 30, 2, 7 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_9
case 9:
	API(SYMVu_ATOMIC_host) < GPU_ARCH, scalar_t, 64, 2, 20, 4, 1 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_10
case 10:
	API(SYMVu_ATOMIC_host) < GPU_ARCH, scalar_t, 64, 4, 28, 2, 9 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_11
case 11:
	API(SYMVu_ATOMIC_host) < GPU_ARCH, scalar_t, 32, 6, 24, 3, 7 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_12
case 12:
	API(SYMVu_ATOMIC_host) < GPU_ARCH, scalar_t, 32, 5, 20, 2, 1 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_13
case 13:
	API(SYMVu_ATOMIC_host) < GPU_ARCH, scalar_t, 128, 2, 28, 2, 0 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_14
case 14:
	API(SYMVu_ATOMIC_host) < GPU_ARCH, scalar_t, 128, 2, 24, 2, 9 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_15
case 15:
	API(SYMVu_ATOMIC_host) < GPU_ARCH, scalar_t, 64, 3, 24, 2, 1 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_16
case 16:
	API(SYMVu_ATOMIC_host) < GPU_ARCH, scalar_t, 64, 2, 20, 4, 7 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_17
case 17:
	API(SYMVu_ATOMIC_host) < GPU_ARCH, scalar_t, 64, 3, 30, 2, 6 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_18
case 18:
	API(SYMVu_ATOMIC_host) < GPU_ARCH, scalar_t, 32, 6, 24, 3, 1 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_19
case 19:
	API(SYMVu_ATOMIC_host) < GPU_ARCH, scalar_t, 64, 4, 28, 2, 7 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
#if KERNEL_20
case 20:
	API(SYMVu_ATOMIC_host) < GPU_ARCH, scalar_t, 32, 6, 24, 3, 9 >
		( n, a, lda, x, y, alpha, beta ); break;
#endif
default:
	break;
}
//==========
}
